module(..., package.seeall)

-- Load libraries
require("controllerfunctions")

default_action = "status"

function status(self)
	return self.model.getstatus()
end

function config(self)
	return controllerfunctions.handle_form(self, self.model.read_config, self.model.update_config, self.clientdata, "Save", "Edit Config", "Configuration Saved")
end

function startstop(self)
	return controllerfunctions.handle_startstop(self, self.model.startstop_service, self.clientdata)
end

function expert(self)
	return controllerfunctions.handle_form(self, self.model.getconfigfile, self.model.setconfigfile, self.clientdata, "Save", "Edit Config", "Configuration Saved")
end

function listrrd(self)
	local configfiles = self.model.getrrdlist()
	local config = {}

	return cfe({ type="list", value=configfiles.value, label="View/Edit RoundRobinDatabase (rrd) files" })
end

function createrrd(self)
	return controllerfunctions.handle_form(self, self.model.createnewrrd, function(value)
			return self.model.savenewrrd(self, value, sessiondata.userinfo.userid)
		end, self.clientdata, "Save", "Create new RRD", "File saved")
end

function delete(self)
	return self:redirect_to_referrer(self.model.remove_file(self, self.clientdata.filename, sessiondata.userinfo.userid))
end

function rrdinfo(self)
	return self:redirect_to_referrer(self.model.rrd_info(self, self.clientdata.filename, sessiondata.userinfo.userid))
end

function listgraphs(self)
	return self.model.list_graphs()
end

function viewgraph(self)
	self.conf.viewtype = "popup"
	return self.model.view_graph(self, self.clientdata.group, self.clientdata.id)
end

function listgraphcfg(self)
	local configfiles = self.model.getgraphlist()
	local config = {}

	return cfe({ type="list", value=configfiles.value, label="View/Edit graph files" })
end

function config(self)
	return nil
end

function editgraphcfg(self)
	config = controllerfunctions.handle_form(self, 
	  function() return self.model.getgraphfile(self.clientdata.filename) end, 
	  function(value)
			return self.model.set_filedetails(self, value, sessiondata.userinfo.userid)
		end, self.clientdata, "Save", "Edit Config File", "Config File Saved")
	
	if self.clientdata.linenumber and validator.is_integer(self.clientdata.linenumber) then
		config.value.filecontent.linenumber = self.clientdata.linenumber
	end
	return config
end

newgraphcfg = editgraphcfg
